#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <complex>
#include <fstream>

#include "fft.h"

using namespace std;

static const double PI = 3.14159265358979323846;
static const complex<double> I = complex<double>(0,1);//Pʂ̐錾
static const int N1 = 8;//ӂ̃TCg
static const double N = N1*N1;//Ŝ̃TCg
static const double A = 1;//iq萔iȂĂj
static const double T = 1;//x
static const double kB = 1;//{c}萔
static const double beta = 1/(kB*T);
static const double dk = 2*PI/(N1*A);//k̍ݕ
static const double dw = 2*PI/beta;
static const double E0 = 5;//ȉno[hf̒萔
static const double t = 2;
static const double U = 2;
static const double u = 1;//w|eV
static const double delta = 0.5;

static const int M = 16;
static const int M4 = 4*M;

#ifndef NMAX//Ȃłȑ傫NMAXĝBȉNMAXSMŒuĂC邯ǁAoOĂ̂ňꉞ`Ă܂
#define NMAX 8192
#define NMAXSQRT 64
#endif

static const int Dyson_steps = 1;

double xi(double kx, double ky);//(k)̌vZ
complex<double> Green0(double kx, double ky, complex<double> w);
double fermi(double E);//tF~z֐
complex<double> chi_0(double qx, double qy, complex<double> w);//_0 w̓{]̏g
complex<double> chi_s(double qx, double qy, complex<double> w);//_s w̓{]̏g
complex<double> chi_c(double qx, double qy, complex<double> w);//_c w̓{]̏g
complex<double> gamma_antiparallel1(double kx, double ky, complex<double> E );//,-Ђkx-qx,ky-qy,iEn-iEm̊֐ɂȂĂ镔 En-Em̓{]̏g
complex<double> gamma_antiparallel2(double kx, double ky, complex<double> E );//,-Ђkx+qx,ky+qy,iEn+iEm̊֐ɂȂĂ镔 En-Em̓{]̏g
complex<double> gamma_parallel(double kx, double ky, complex<double> E );//, kx-qx,ky-qy,iEn-iEm̊֐ɂȂĂ En-Em̓{]̏g

void onestep_Dyson(complex<double>g0ek[N1][N1][M],complex<double>g0rt[N1][N1][2*M],complex<double>gek[N1][N1][M],complex<double>grt[N1][N1][2*M],complex<double>gpt[N1][N1][2*M],complex<double>c0t[N1][N1][2*M]);

#include "do_fft.h"//IcÑt[Gϊ֌W̊֐ɂڂ܂B

int main(void){
	int i1,i2,i3,i4,i,j;
	complex<double> chi0w[N1][N1][M+1],gamma_antiparallel1_w[N1][N1][M+1],gamma_antiparallel2_w[N1][N1][M+1],gamma_parallel_w[N1][N1][M+1];
	complex<double> chi0t[N1][N1][2*M],gamma_antiparallel1_t,gamma_parallel_t[N1][N1][2*M];
	complex<double> Green0_ek[N1][N1][M] ,Green_ek[N1][N1][M];
	complex<double> Green0_er[N1][N1][M] ;
	complex<double> Green0_tr[N1][N1][M*2],Green_tr[N1][N1][M*2];

	//@0̌vZ
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1 ;i2++){
			for(i3=0; i3<M+1; i3++){
				chi0w[i1][i2][i3] = chi_0(static_cast<double>(i1)*dk, static_cast<double>(i2)*dk, I*PI*(2*static_cast<double>(i3))/beta);
			}
		}
	}
	//0̎ԋfourierϊ(kw)(rt)
	Chi3_fft2d(chi0w, -1);
	Chi3_fft1d(chi0t, chi0w, -1);
	
	/*B,-Ђ̌vZ
	sXsԗLݍṕAkx-qx,ky-qy,iEn-iEm̊֐ɂȂĂĂȂ̂ŁA
	kx-qx,ky-qy,iEn-iEm̊֐ɂȂĂ镔kx+qx,ky+qy,iEn+iEm̊֐ɂȂĂ镔ɕĎgp܂B
	*/	
	//B-1,-Ђ̌vZ(1) kɂk-qAEɂEn-EmĎgƂɂȂ܂B
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1 ;i2++){
			for(i3=0; i3<M+1; i3++){
					gamma_antiparallel1_w[i1][i2][i3] = gamma_antiparallel1(static_cast<double>(i1)*dk, static_cast<double>(i2)*dk, I*PI*(2*static_cast<double>(i3))/beta);
			}
		}
	}
	

	//B-2,-Ђ̌vZ(2) kɂk+qAEɂEn+EmĎgƂɂȂ܂B
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1 ;i2++){
			for(i3=0; i3<M+1; i3++){
					gamma_antiparallel2_w[i1][i2][i3] = gamma_antiparallel2(static_cast<double>(i1)*dk, static_cast<double>(i2)*dk, I*PI*(2*static_cast<double>(i3))/beta);
			}
		}
	}
	//C,(kx,ky,iE)̌vZ kɂk-qAEɂEn-EmĎgƂɂȂ܂B
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1 ;i2++){
			for(i3=0; i3<M+1; i3++){
				gamma_parallel_w[i1][i2][i3] = gamma_parallel(static_cast<double>(i1)*dk, static_cast<double>(i2)*dk, I*PI*(2*static_cast<double>(i3))/beta);
			}
		}
	}
	//,Ђ̎ԋfourierϊ(kw)(rt)
	Chi3_fft2d(gamma_parallel_w, -1);
	Chi3_fft1d(gamma_parallel_t, gamma_parallel_w, -1);

	//G0̌vZ
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<M; i3++){
				Green0_ek[i1][i2][i3] = Green0(static_cast<double>(i1)*dk, static_cast<double>(i2)*dk, I*PI*(2.0*static_cast<double>(i3)+1)/beta);
				Green0_er[i1][i2][i3] = Green0_ek[i1][i2][i3];//Green0(r,ie)ʂɎgȂ̂łAGreen0(r,t)rGreen0(t,ie)ȂȂƍ̂
			}
		}
	}
	//G̏lKȂƂāA_C\ɒ(G0炾Ƃ܂Ȃ)
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<M; i3++){
				Green_ek[i1][i2][i3] = Green0_ek[i1][i2][i3]+0.1*i1*i2;
			}
		}
	}

	Green3_fft2d(Green0_er, -1);//̂߂Green0(r,ie)܂B
	Green3_fft1d(Green0_tr, Green0_er, -1);//Green0(r,t)B




	//DG(kx,ky,iEn)̌vZi_C\j
	for(i=0; i<Dyson_steps ; i++){
		onestep_Dyson(Green0_ek, Green0_tr,Green_ek,Green_tr, chi0t, gamma_parallel_t);
	}

	ofstream outfile("Green.dat");
	outfile << "#	kx	ky	Green_ek" << endl;
	for(int i=0;i<N1;i++)
	{
		for(int j=0;j<N1;j++)
		{
			outfile << dk*i << " " << dk * j<< " " << Green_ek[i][j][3] << endl; 
		}
	}

	ofstream outfile2("Green0.dat");
	outfile2 << "#	kx	ky	Green0_ek" << endl;
	for(int i=0;i<N1;i++)
	{
		for(int j=0;j<N1;j++)
		{
			outfile2 << dk*i << " " << dk * j<< " " << Green0_ek[i][j][3] << endl; 
		}
	}

	//E(kx,ky,iEn)̌vZiMbvj

	return 0;
}








double xi(double kx, double ky){
	return E0+2*t*(cos(kx*A)+cos(ky*A))-u;
}

complex<double> Green0(double kx, double ky, complex<double> w){
	return complex<double>(1,0)/(w-xi(kx, ky));
}

double fermi(double E){
	return 1/(1+exp(beta*E));
}

complex<double> chi_0(double qx, double qy, complex<double> w){
	complex<double> chi = complex<double>(0,0);
	int i,j;
	double kx, ky;
	for(i=0; i<N1; ++i){
		kx = static_cast<double>(i)*dk;//ӂdouble^Ȃ̂ŁAEӂint^̂̂double^ɃLXgi^ϊjĂB
		for(j=0; j<N1; ++j){
			ky = static_cast<double>(j)*dk;
			if( w-(xi(kx+qx, ky+qy)-xi(kx, ky)) != complex<double>(0,0) ){
			chi += (fermi(xi(kx+qx, ky+qy))-fermi(xi(kx, ky)))/(w-(xi(kx+qx, ky+qy)-xi(kx, ky)));
			}
		}
	}
	chi = chi/N;
	return chi;
}

complex<double> chi_s(double qx, double qy, complex<double> w){
	return chi_0(qx, qy, w)/(complex<double>(1,0)-U*chi_0(qx, qy, w));
}

complex<double> chi_c(double qx, double qy, complex<double> w){
	return chi_0(qx, qy, w)/(complex<double>(1,0)+U*chi_0(qx, qy, w));
}

complex<double> gamma_antiparallel1(double kx, double ky, complex<double> E ){
	return U - chi_c(kx,ky,E)*U*U/complex<double>(2,0) + chi_s(kx,ky,E)*U*U/complex<double>(2,0) ;
}//kɂk-qAEɂEn-EmĎgƂɂȂ܂B

complex<double> gamma_antiparallel2(double kx, double ky, complex<double> E ){
	return chi_s(kx,ky,E) *U*U;
}//kɂk+qAEɂEn+EmĎgƂɂȂ܂B

complex<double> gamma_parallel(double kx, double ky, complex<double> E ){
	return -chi_c(kx,ky,E)*U*U/complex<double>(2,0) - complex<double>(3,0)*chi_s(kx,ky,E)*U*U/complex<double>(2,0);
}//kɂk-qAEɂEn-EmĎgƂɂȂ܂B

void onestep_Dyson(complex<double>g0ek[N1][N1][M],complex<double>g0tr[N1][N1][M*2],complex<double>gek[N1][N1][M],complex<double>gtr[N1][N1][M*2],complex<double>gpt[N1][N1][2*M],complex<double>c0t[N1][N1][2*M]){
	complex<double> sigma_tr[N1][N1][2*M];
	complex<double> sigma_ek[N1][N1][M];
	int i1,i2,i3;

	Green3_fft2d(gek, -1);
	Green3_fft1d(gtr, gek, -1);//Green(r,t)B

	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<2*M; i3++){
				sigma_tr[i1][i2][i3] = (gtr[i1][i2][i3]*gpt[i1][i2][i3]-U*U*g0tr[i1][i2][i3]*c0t[i1][i2][i3]);
			}
		}
	}
/*	ofstream outfile3("sigma.dat");
	outfile3 << "#	kx	ky	sigma_trk" << endl;
	for(int i=0;i<N1;i++)
	{
		for(int j=0;j<N1;j++)
		{
			outfile3 << dk*i << " " << dk * j<< " " << sigma_tr[i][j][3] << endl; 
		}
	}*/
	Green3_fft1d(sigma_tr, sigma_ek, 1);
	Green3_fft2d(sigma_ek, 1);
	for(i1=0; i1<N1; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<M; i3++){
				gek[i1][i2][i3] = g0ek[i1][i2][i3]/ ( 1.0 -g0ek[i1][i2][i3]*sigma_ek[i1][i2][i3]  ) ;
			}
		}
	}
}


