void do_fft1(complex<double> ca[], int flag);//fzflagɉăt[Gϊortt[GϊĂBdo_fft1͎g킸
void do_fft2(complex<double> ca[][N1], int flag);
void do_fft1_M4(complex<double> ca[], int flag);

void Green_w_t(complex<double> gw[], complex<double> gt[]);//k邢rł̃-уt[Gϊs֐
void Green_t_w(complex<double> gt[], complex<double> gw[]);
void Chi_w_t(complex<double> cw[], complex<double> ct[]);
void Chi_t_w(complex<double> ct[], complex<double> cw[]);

//ȉ̊֐͏̊֐JԂĂяoƂŁASĂk邢rł̃-уt[GϊsB
void Green3_fft2d(complex<double> g[][N1][M], int flag);//flag==1r-k flag==-1k-r
void Green3_fft1d(complex<double> gt[N1][N1][M*2], complex<double> gw[N1][N1][M], int flag);//flag==1Ńсց@flag==-1Ńց
void Chi3_fft2d(complex<double> c[][N1][M+1], int flag);//flag==1r-k flag==-1k-r
void Chi3_fft1d(complex<double> ct[N1][N1][M*2], complex<double> cw[N1][N1][M+1], int flag);//flag==1Ńсց@flag==-1Ńց
void tfunc_fft2d(complex<double> f[][N1][M*2], int flag);//flag==1r-k flag==-1k-r

void do_fft1(complex<double> ca[], int flag){
	int ip[NMAXSQRT + 2], j;
    double a[NMAX + 1], w[NMAX * 5 / 4];//ȑ傫ȔzɂKv͂Ȃ

	if(flag*flag != 1){cout << "flag error" << endl;}

	for(j=0; j<NMAX+1; ++j){
		a[j] = 0;
	}

	for(j=0; j<M; ++j){
		a[j*2] = real(ca[j]);
		a[j*2+1] = imag(ca[j]);
	}

	ip[0] = 0;

	cdft(2*M, flag, a, ip, w);

	for(j=0; j<M; j++){
		ca[j] = a[2*j]+I*a[2*j+1];
	}

	free(ip);
	free(a);
	free(w);
}


void do_fft2(complex<double> ca[ ][N1], int flag){//̊֐ł1/N̕␳͂ȂB
	int *ip, m, i;
	int j1, j2 ;
	double **a, *w;

	if(flag*flag != 1){cout << "flag error" << endl;}

	a = alloc_2d_double(N1, 2*N1);

    ip = alloc_1d_int(2 + (int) sqrt(N + 0.5));
    m = N1/2 + 2*N1;
    w = alloc_1d_double(m);
    ip[0] = 0;
    
	for (j1 = 0; j1 < N1; j1++) {
		for (j2 = 0; j2 < N1; j2++) {
			a[j1][j2*2] = real(ca[j1][j2]) ;//
			a[j1][j2*2+1] = imag(ca[j1][j2]) ;//
		}
	}
	
	cdft2d(N1, 2*N1, flag, a, ip, w);//a[j1][j2]Fourierϊ  a[k1][k2]

	for (j1 = 0; j1 < N1; j1++) {
		for (j2 = 0; j2 < N1; j2++) {
			ca[j1][j2] = a[j1][j2*2]+I*a[j1][j2*2+1];
		}
	}

    free_1d_double(w);
    free_1d_int(ip);
    free_2d_double(a);

}

void do_fft1_M4(complex<double> ca[], int flag1, int flag2){
	int ip[NMAXSQRT + 2], j;
    double a[NMAX + 1], w[NMAX * 5 / 4];//ȑ傫ȔzɂKv͂Ȃ

	if(flag1*flag1 != 1){cout << "flag error" << endl;}

	for(j=0; j<NMAX+1; ++j){
		a[j] = 0;
	}

	for(j=0; j<M4; ++j){
		a[j*2] = real(ca[j]);
		a[j*2+1] = imag(ca[j]);
	}

	ip[0] = 0;

	cdft(2*M4, flag1, a, ip, w);

	if(flag2 == 1){
		for(j=0; j<2*M4; j++){
			a[j] *= 1.0/M4;
		}
	}

	for(j=0; j<M4; j++){
		ca[j] = a[2*j]+I*a[2*j+1];
	}

	free(ip);
	free(a);
	free(w);
}


void Green_w_t(complex<double> gw[], complex<double> gt[]){
	complex<double> aw[4*M];
	int i;

	for(i=0; i<2*M; i++){
		aw[2*i] = 0;
	}

	for(i=0; i<M; i++){
		aw[2*i+1] = gw[i];
	}

	for(i=M; i<2*M; i++){
		aw[2*i+1] = conj(gw[2*M-i-1]);
	}

	do_fft1_M4(aw, -1,0);

	for(i=0; i<2*M; i++){
		gt[i] = aw[i]/beta;
	}

	free(aw);
}

void Green_t_w(complex<double> gt[], complex<double> gw[]){
	complex<double> at[4*M];
	int i;

	for(i=0; i<2*M; i++){
		at[i] = gt[i];
	}

	for(i=2*M; i<4*M; i++){
		at[i] = -gt[i-2*M];
	}

	do_fft1_M4(at, 1, 1);

	for(i=0; i<M; i++){
		gw[i] = at[2*i+1]*beta;
	}

	free(at);
}

void Chi_t_w(complex<double> ct[], complex<double> cw[]){
	complex<double> at[4*M];
	int i;

	for(i=0; i<2*M; i++){
		at[i] = ct[i];
	}

	for(i=2*M; i<4*M; i++){
		at[i] = ct[i-2*M];
	}

	do_fft1_M4(at, 1, 1);

	for(i=0; i<M+1; i++){
		cw[i] = at[2*i]*beta;
	}

	free(at);
}

void Chi_w_t(complex<double> cw[], complex<double> ct[]){
	complex<double> aw[4*M];
	int i;

	for(i=0; i<2*M; i++){
		aw[2*i+1] = 0;
	}

	for(i=0; i<M; i++){
		aw[2*i] = cw[i];
	}

	for(i=M; i<2*M; i++){
		aw[2*i] = conj(cw[2*M-i]);
	}

	aw[2*M] = complex<double>(real(aw[2*M]), 0);
	aw[0] = complex<double>(real(aw[0]), 0);//{Ă͂ǁA덷邽߁B

	do_fft1_M4(aw, -1, 0);

	for(i=0; i<2*M; i++){
		ct[i] = aw[i]/beta;
	}

	free(aw);
}

void Green3_fft2d(complex<double> g[][N1][M], int flag){//flag==1r-k flag==-1k-r
	complex<double> ar[N1][N1];
	int i1, i2, i3;

	for(i1=0; i1<M; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				ar[i2][i3] = g[i2][i3][i1];
			}
		}
		do_fft2(ar, -flag);
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				g[i2][i3][i1] = ar[i2][i3];
				if(flag==-1){ g[i2][i3][i1] *= 1/N; }
			}
		}
	}
	free(ar);
}

void Chi3_fft2d(complex<double> c[][N1][M+1], int flag){//flag==1r-k flag==-1k-r
	complex<double> ar[N1][N1];
	int i1, i2, i3;

	for(i1=0; i1<M+1; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				ar[i2][i3] = c[i2][i3][i1];
			}
		}
		do_fft2(ar, -flag);
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				c[i2][i3][i1] = ar[i2][i3];
				if(flag==-1){ c[i2][i3][i1] *= 1/N; }
			}
		}
	}
	free(ar);
}

void tfunc_fft2d(complex<double> f[][N1][M*2], int flag){//flag==1r-k flag==-1k-r
	complex<double> ar[N1][N1];
	int i1, i2, i3;

	for(i1=0; i1<M*2; i1++){
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				ar[i2][i3] = f[i2][i3][i1];
			}
		}
		do_fft2(ar, -flag);
		for(i2=0; i2<N1; i2++){
			for(i3=0; i3<N1; i3++){
				f[i2][i3][i1] = ar[i2][i3];
				if(flag==-1){ f[i2][i3][i1] *= 1/N; }
			}
		}
	}
	free(ar);
}

void Green3_fft1d(complex<double> gt[N1][N1][M*2], complex<double> gw[N1][N1][M], int flag){//flag==1Ńсց@flag==-1Ńց
	complex<double> at[M*2], aw[M];
	int i1, i2, i3;

	if(flag==1){
		for(i1=0; i1<N1; i1++){
			for(i2=0; i2<N1; i2++){
				for(i3=0; i3<M*2; i3++){
					at[i3] = gt[i1][i2][i3];
				}
				Green_t_w(at, aw);
				for(i3=0; i3<M; i3++){
					gw[i1][i2][i3] = aw[i3];
				}
			}
		}
	}

	if(flag==-1){
		for(i1=0; i1<N1; i1++){
			for(i2=0; i2<N1; i2++){
				for(i3=0; i3<M; i3++){
					aw[i3] = gw[i1][i2][i3];
				}
				Green_w_t(aw, at);
				for(i3=0; i3<M*2; i3++){
					gt[i1][i2][i3] = at[i3];
				}
			}
		}
	}

	free(at);
	free(aw);
}

void Chi3_fft1d(complex<double> ct[N1][N1][M*2], complex<double> cw[N1][N1][M+1], int flag){//flag==1Ńсց@flag==-1Ńց
	complex<double> at[M*2], aw[M+1];
	int i1, i2, i3;

	if(flag==1){
		for(i1=0; i1<N1; i1++){
			for(i2=0; i2<N1; i2++){
				for(i3=0; i3<M*2; i3++){
					at[i3] = ct[i1][i2][i3];
				}
				Chi_t_w(at, aw);
				for(i3=0; i3<M+1; i3++){
					cw[i1][i2][i3] = aw[i3];
				}
			}
		}
	}

	if(flag==-1){
		for(i1=0; i1<N1; i1++){
			for(i2=0; i2<N1; i2++){
				for(i3=0; i3<M+1; i3++){
					aw[i3] = cw[i1][i2][i3];
				}
				Chi_w_t(aw, at);
				for(i3=0; i3<M*2; i3++){
					ct[i1][i2][i3] = at[i3];
				}
			}
		}
	}

	free(at);
	free(aw);
}